const Role = require('../../models/Role');


module.exports = {
    Query: {
        async roles() {
            try {
                const roles = await Role.find().sort({ createdAt: -1 });
                return roles;
            } catch (err) {
                throw new Error(err);
            }
        },
        async role(_, { itemId }) {
            try {
                const role = await Role.findById(itemId);
                if (role) {
                    return role;
                } else {
                    throw new Error('Role not found');
                }
            } catch (err) {
                throw new Error(err);
            }
        }
	},
	Mutation: {
		async updateRole(_, { id, name, desc }, context) {
			try {
				let item;
				if (!id || id === 'new') {
					item = new Role({
						name,
						desc,
						createdAt: new Date().toISOString()
					});
				} else {
					item = await Role.findById(id);
					if (name !== undefined) item.name = name;
					if (desc !== undefined) item.desc = desc;
					item.createdAt =  new Date().toISOString();
				}
				await item.save();
				return item.id;
			} catch (err) {
				throw new Error(err);
			}
		},

		async deleteRole(_, { itemId }, context) {
			try {
				const item = await Role.findById(itemId);
				await item.delete();
				return 'deleted successfully';
			} catch (err) {
				throw new Error(err);
			}
		},

	}
};
